#include <popt.h>

/*
  Command-line options configuration for the trish-* executables

*/

#ifndef HAVE_CL_CONFIG_H
#define HAVE_CL_CONFIG_H

#define CL_VERBOSITY_OPTIONS {\
  { CLOL_QUIET   , CLOS_QUIET   , POPT_ARG_NONE  , NULL    , CLOV_QUIET   , CLOH_QUIET   , NULL },\
  { CLOL_VERBOSE , CLOS_VERBOSE , POPT_ARG_NONE  , NULL    , CLOV_VERBOSE , CLOH_VERBOSE , NULL },\
  { CLOL_LOCACE  , CLOS_LOCACE  , POPT_ARG_NONE  , NULL    , CLOV_LOCACE  , CLOH_LOCACE  , NULL },\
  { CLOL_STRICT  , CLOS_STRICT  , POPT_ARG_NONE  , NULL    , CLOV_STRICT  , CLOH_STRICT  , NULL },\
  POPT_TABLEEND\
}


#define CLOL_QUIET              "quiet"
#define CLOL_VERBOSE            "verbose"
#define CLOL_LOCACE             "locace"
#define CLOL_STRICT             "strict"

#define CLOL_CFLAGS             "cflags"
#define CLOL_CLIBS              "clibs"

#define CLOL_OPT_MNB            "opt-mnb"
#define CLOL_OPT_MSB            "opt-msb"
#define CLOL_OPT_NENTRIES       "opt-entries"
#define CLOL_OPT_TAGSIZE        "opt-tagsize"
#define CLOL_OPT_TNB            "opt-tnb"
#define CLOL_OPT_TSB            "opt-tsb"

#define CLOL_COMPILED_DICT      "compiled-dict"
#define CLOL_DICT_MAX_LENGTH    "dict-max-length"
#define CLOL_TAG_DELIMITERS     "tag-delimiters"
#define CLOL_MULTI_DICT         "multi-dict"
#define CLOL_DICT_ENCODING      "dict-encoding"
#define CLOL_HEADERS            "headers"

#define CLOL_INPUT              "input"
#define CLOL_OUTPUT             "output"
#define CLOL_SEARCH_MAX_LENGTH  "search-max-length"
#define CLOL_SEARCH_ENCODING    "search-encoding"
#define CLOL_SUBSTRINGS         "substrings"
#define CLOL_WORDS              "words"
#define CLOL_CI_ALL             "case-insensitive"
#define CLOL_CI_FIRST           "capital-insensitive"
#define CLOL_GCI_ALL            "general-case-insensitive"
#define CLOL_GCI_FIRST          "general-capital-insensitive"
#define CLOL_GCI_TABLE          "gci-table"
#define CLOL_FORMAT_YES         "format-yes"
#define CLOL_FORMAT_NO          "format-no"
#define CLOL_SHOW_HEADERS       "show-headers"

#define CLOL_VERSION            "version"
#define CLOL_NO_SEARCH          "no-search"
#define CLOL_DISPLAY_OPT        "optimal-parameters"
#define CLOL_SAVE_AS            "save-as"



#define CLOS_QUIET              'q'
#define CLOS_VERBOSE            'v'
#define CLOS_LOCACE             'V'
#define CLOS_STRICT             's'

#define CLOS_CFLAGS             '\0'
#define CLOS_CLIBS              '\0'

#define CLOS_OPT_MNB            '\0'
#define CLOS_OPT_MSB            '\0'
#define CLOS_OPT_NENTRIES       '\0'
#define CLOS_OPT_TAGSIZE        '\0'
#define CLOS_OPT_TNB            '\0'
#define CLOS_OPT_TSB            '\0'

#define CLOS_COMPILED_DICT      'd'
#define CLOS_DICT_MAX_LENGTH    'X'
#define CLOS_TAG_DELIMITERS     'a'
#define CLOS_MULTI_DICT         'm'
#define CLOS_DICT_ENCODING      'E'
#define CLOS_HEADERS            'H'

#define CLOS_INPUT              'i'
#define CLOS_OUTPUT             'o'
#define CLOS_SEARCH_MAX_LENGTH  'x'
#define CLOS_SEARCH_ENCODING    'e'
#define CLOS_SUBSTRINGS         'w'
#define CLOS_WORDS              'W'
#define CLOS_CI_ALL             'c'
#define CLOS_CI_FIRST           'C'
#define CLOS_GCI_ALL            'g'
#define CLOS_GCI_FIRST          'G'
#define CLOS_GCI_TABLE          't'
#define CLOS_FORMAT_YES         'Y'
#define CLOS_FORMAT_NO          'N'
#define CLOS_SHOW_HEADERS       'h'

#define CLOS_VERSION            '\0'
#define CLOS_DISPLAY_OPT        'P'
#define CLOS_NO_SEARCH          'n'
#define CLOS_SAVE_AS            'D'



#define CLOH_QUIET              "Be quiet"
#define CLOH_VERBOSE            "Be verbose"
#define CLOH_LOCACE             "Be even more verbose"
#define CLOH_STRICT             "Abort when a warning is issued"

#define CLOH_CFLAGS             "Display GCC options for compiling"
#define CLOH_CLIBS              "Display GCC options for linking"

#define CLOH_OPT_MNB            "Estimated number of nodes in the entries tree"
#define CLOH_OPT_MSB            "Estimated total length of follow strings in the entries tree"
#define CLOH_OPT_NENTRIES       "Estimated number of nodes in the tags tree"
#define CLOH_OPT_TAGSIZE        "Estimated total length of follow strings in the tags tree"
#define CLOH_OPT_TNB            "Estimated number of entries"
#define CLOH_OPT_TSB            "Estimated number of distinct tags"

#define CLOH_COMPILED_DICT      "Dictionary has already been compiled, will ignore all other dictionary options"
#define CLOH_DICT_MAX_LENGTH    "Maximum number of characters of a dictionary line"
#define CLOH_TAG_DELIMITERS     "Tag delimiters of the dictionary"
#define CLOH_MULTI_DICT         "Allow multiple instances for a single entry"
#define CLOH_DICT_ENCODING      "Encoding of the dictionary file"
#define CLOH_HEADERS            "The first line of the dictionary gives the headers, must have all delimiters given by --" CLOL_TAG_DELIMITERS

#define CLOH_INPUT              "Read queries from this file, standard input by default"
#define CLOH_OUTPUT             "Query results to this file, standard output by default"
#define CLOH_SEARCH_MAX_LENGTH  "Maximum number of characters of a query line"
#define CLOH_SEARCH_ENCODING    "Query and output encoding"
#define CLOH_SUBSTRINGS         "Look for entries in the query substrings"
#define CLOH_WORDS              "Only look for entries in query substrings that form a word, only useful with --" CLOL_SUBSTRINGS
#define CLOH_CI_ALL             "Perform case insensitive search on all characters"
#define CLOH_CI_FIRST           "Perform case insensitive search on the first character of each query"
#define CLOH_GCI_ALL            "Perform GCI search on all characters"
#define CLOH_GCI_FIRST          "Perform GCI search on the first character of each query"
#define CLOH_GCI_TABLE          "Path to the GCI file"
#define CLOH_FORMAT_YES         "Display format for found queries"
#define CLOH_FORMAT_NO          "Display format for not found queries"
#define CLOH_SHOW_HEADERS       "Display a line with headers using the format given by --" CLOL_FORMAT_YES

#define CLOH_VERSION            "Print version and exit"
#define CLOH_DISPLAY_OPT        "Print optimal parameters options to standard output"
#define CLOH_NO_SEARCH          "Do not perform any search, will ignore all search options"
#define CLOH_SAVE_AS            "Save dictionary in a compiled form, for future use with --" CLOL_COMPILED_DICT




#define CLOV_QUIET            1
#define CLOV_VERBOSE          2
#define CLOV_LOCACE           3
#define CLOV_STRICT           4
#define CLOV_CI_ALL           5
#define CLOV_CI_FIRST         6
#define CLOV_FORMAT_NO        7
#define CLOV_FORMAT_YES       8
#define CLOV_GCI_ALL          9
#define CLOV_GCI_FIRST       10
#define CLOV_SUBSTRINGS      11
#define CLOV_TAG_DELIMITERS  12
#define CLOV_VERSION         13
#define CLOV_CFLAGS          14
#define CLOV_CLIBS           15

#endif
