#ifndef HAVE_DEFAULTS_H
#define HAVE_DEFAULTS_H

/* DEFAULT_MAX_LINE_LENGTH - Default maximal length for an input line (search query or dictionary entry) */
#define DEFAULT_MAX_LINE_LENGTH 1024


/* DEFAULT_OPT_* - Default optimal paramaters */
#define DEFAULT_OPT_MNB      3000
#define DEFAULT_OPT_MSB      1024
#define DEFAULT_OPT_TNB      500
#define DEFAULT_OPT_TSB      1024
#define DEFAULT_OPT_NENTRIES 10000
#define DEFAULT_OPT_TAGSIZE  1000


/* DEFAULT_VERBOSITY - Default verbosity level */
#define DEFAULT_VERBOSITY    V_NORMAL

/* DEFAULT_SEVERITY - Default severity level */
#define DEFAULT_SEVERITY     V_ERROR


/* DEFAULT_SEARCH_OPTIONS - Default options for patricia_search */
#define DEFAULT_SEARCH_OPTIONS PSEARCH_OPTION_FULL


/* DEFAULT_OPT_DENSITY - Default optimal parameter for search bunch */
#define DEFAULT_OPT_DENSITY  1


/* DEFAULT_FORMAT_YES - Default yes-format */
#define DEFAULT_FORMAT_YES "{match}\\n"

/* DEFAULT_LONG_FORMAT_YES - Default yes-format in wide characters */
#define DEFAULT_LONG_FORMAT_YES L"{match}\\n"

/* DEFAULT_DISPLAY_BLOCK - Default display length */
#define DEFAULT_DISPLAY_BLOCK 123


/* DEFAULT_GCI_* - Default optimal parameters for GCI table */
#define DEFAULT_GCI_NWC  111
#define DEFAULT_GCI_NALT 222

/* DEFAULT_GCI_MAX_LENGTH - Maximal number of alternatives for a GCI character */
#define DEFAULT_GCI_MAX_LENGTH 1024


/* DEFAULT_ENCODING - Default value for LC_CTYPE */
#define DEFAULT_ENCODING "C"




#endif
