/*
  Copyright (C) 1988-1994,1996-1999,2003,2004 Free Software Foundation, Inc.
  This file is part of the GNU C Library.  Its master source is NOT part of
  the C library, however.  The master source lives in /gd/gnu/lib.

  The GNU C Library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  The GNU C Library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with the GNU C Library; if not, write to the Free
  Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
  02111-1307 USA.
*/

#include "gci.h"

#include <wchar.h>

patricia_t *gci_new(unsigned int nwc, unsigned int nalt) {
  return patricia_new(nwc, nalt, NULL);
}

int gci_add(patricia_t *gci, wchar_t wc, wchar_t *alt) {
  pnode_t *pn;
  int l = wcslen(alt);

  if (pnode_insert(gci->nodes, gci->root, PNODE_TYPE_CHAR, wc, &pn))
    return 0;

  pn->follow_string = bunch_claim(gci->follow_strings, l + 1);
  wcscat(pn->follow_string, alt);
  return 1;
}

wchar_t *gci_alt(patricia_t *gci, wchar_t wc) {
  pnode_t *pn = pnode_lookup(gci->root, PNODE_TYPE_CHAR, wc);

  if (pn == NULL)
    return NULL;
  return pn->follow_string;
}
