#include "cl_config.h"
#include "defaults.h"
#include "verbosity.h"

struct poptOption cl_options[] = {
  POPT_AUTOHELP
  { CLOL_CFLAGS , CLOS_CFLAGS , POPT_ARG_NONE , NULL , CLOV_CFLAGS , CLOH_CFLAGS , NULL },
  { CLOL_CLIBS  , CLOS_CLIBS  , POPT_ARG_NONE , NULL , CLOV_CLIBS  , CLOH_CLIBS  , NULL },
  POPT_TABLEEND
};

int main(int argc, const char **argv) {
  int opth;
  poptContext context = poptGetContext(NULL, argc, argv, cl_options, 0);

  while ((opth = poptGetNextOpt(context)) > 0) {
    switch (opth) {
    case CLOV_CFLAGS:
      printf(" -I%s", INCDIR);
      break;
    case CLOV_CLIBS:
      printf(" -ltrish2-dictionary -ltrish2-patricia -ltrish2-bunch -L%s", LIBDIR);
      break;
    }
  }
  if (opth != -1) {
    verbosity_message(V_QUIET | V_ERROR, "%s %s", poptStrerror(opth), poptBadOption(context, 0));
  }
  printf("\n");
  poptFreeContext(context);

  return 0;
}
